namespace PkmnLib.Plugin.Gen7.Scripts.Abilities;

/// <summary>
/// Stamina is an ability that raises the user's Defense by one stage when hit by an attack.
///
/// <see href="https://bulbapedia.bulbagarden.net/wiki/Stamina_(Ability)">Bulbapedia - Stamina</see>
/// </summary>
[Script(ScriptCategory.Ability, "stamina")]
public class Stamina : Script, IScriptOnIncomingHit
{
    /// <inheritdoc />
    public void OnIncomingHit(IExecutingMove move, IPokemon target, byte hit)
    {
        EventBatchId batchId = new();
        if (target.ChangeStatBoost(Statistic.Defense, 1, true, false, batchId))
        {
            move.Battle.EventHook.Invoke(new AbilityTriggerEvent(target)
            {
                BatchId = batchId,
            });
        }
    }
}